- name: Kill any process using port 5000
  command: fuser -k 5000/tcp
  become: true
  ignore_errors: true

- name: Start Order API Server
  ansible.builtin.shell: |
    nohup {{ project_directory }}/venv/bin/python3 {{ project_directory }}/src/fake_ex_order_api/main.py {{conn_type}} > /dev/null 2>&1 &
  args:
    chdir: "{{ project_directory }}"
  poll: 0
  register: order_api_server_task

- name: Wait for the server to start
  pause:
    seconds: 3 # Adjust based on the expected startup time of your server

- name: Check if Order API Server process is running
  ansible.builtin.shell: pgrep -f "{{ project_directory }}/venv/bin/python3 {{ project_directory }}/src/fake_ex_order_api/main.py"
  register: order_api_process_check
  failed_when: order_api_process_check.rc != 0

- name: Print the pgrep result
  ansible.builtin.debug:
    msg: |
      Order API process pgrep result:
        STDOUT: {{ order_api_process_check.stdout_lines }}
        STDERR: {{ order_api_process_check.stderr_lines }}

- name: Ensure Order API Server is listening on its port
  ansible.builtin.wait_for:
    host: "127.0.0.1" # or your specific server host
    port: 5000 # replace with your server's port
    state: started
    timeout: "{{ capture_duration + 20 }}" # Adjust based on how long you want to wait
  register: order_api_server_port_check

- name: Check Order API Server endpoint
  ansible.builtin.uri:
    url: http://127.0.0.1:5000/order # replace with your server's URL and a known working endpoint
    method: POST
    body: '{"key": "value"}' # Adjust this with actual data your API expects, if necessary
    body_format: json
    return_content: yes
    headers:
      Content-Type: "application/json" # Ensure this is set if your API expects JSON
    validate_certs: no # Set to yes in production if you have a valid certificate
  register: order_api_endpoint_check
  until: order_api_endpoint_check.status == 200
  retries: 5
  delay: 5 # Delay between retries, adjust as needed
